/*******************************************************************
  Components for embedded applications builded for
  laboratory and medical instruments firmware  
 
  flash0.S - FLASH boot block startup code
 
  Copyright (C) 2001-2003 by Pavel Pisa pisa@cmp.felk.cvut.cz
            (C) 2001-2003 by PiKRON Ltd. http://www.pikron.com

 *******************************************************************/

#include <mx1_def.h>

.text
.code 32

.global _flash_start
.global _crt_start
.global _exit
.global __excpt_pass_undef
.global __excpt_pass_swi
.global __excpt_pass_pref_abort
.global __excpt_pass_data_abort
.global __excpt_pass_irq
.global __excpt_pass_fiq

_flash_start :
	b	.LC_excpt_reset
	ldr	pc,.LC_pass_undef
	ldr	pc,.LC_pass_swi
	ldr	pc,.LC_pass_pref_abort
	ldr	pc,.LC_pass_data_abort
	.word	0
	ldr	pc,.LC_pass_irq
	ldr	pc,.LC_pass_fiq

	.word	0
.LC_pass_undef :
	.word	__excpt_pass_undef
.LC_pass_swi :
	.word	__excpt_pass_swi
.LC_pass_pref_abort :
	.word	__excpt_pass_pref_abort
.LC_pass_data_abort :
	.word	__excpt_pass_data_abort
	.word	0
.LC_pass_irq :
	.word	__excpt_pass_irq
.LC_pass_fiq :
	.word	__excpt_pass_fiq
     
.LC_excpt_reset :
	mrs	r1,cpsr
	orr	r1,r1,#0xc0	/* IBIT | FBIT  */
	msr	cpsr_c,r1
	ldr	r1,=EIM_CS5H
	mov	r2,#1
	str	r2,[r1]

	mov	r1,#EIM_CS0H
	/*mov	r2,#0x00002000*/
	ldr	r2,=0x00004f42	/* Setup FLASH parameters */
	str	r2,[r1],#4
	ldr	r2,=0x00000D01	/* Setup FLASH parameters */
	str	r2,[r1],#4

	ldr	r1,=CRM_CSCR
	ldr	r2,=0xE7000402
	str	r2,[r1]

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	/* Set general purpose ports directions and functions */
	ldr	r1,=PTB_BASE_ADDR
	mov     r2,#0xc0000000
	str     r2,[r1, #(PTB_DDIR-PTB_BASE_ADDR)]
	mvn     r2,#0xc0000000
	str     r2,[r1, #(PTB_GIUS-PTB_BASE_ADDR)]
	mov     r2,#0
	str     r2,[r1,#(PTB_GPR-PTB_BASE_ADDR)]
	ldr     r1,=PTC_BASE_ADDR
	mov     r2,#0x1800
	str     r2,[r1,#(PTC_DDIR-PTC_BASE_ADDR)]
	mvn     r2, #0x1800
	str     r2,[r1,#(PTC_GIUS-PTC_BASE_ADDR)]
	mov     r2, #0
	str     r2,[r1,#(PTC_GPR-PTC_BASE_ADDR)]

	ldr     r10, =0x5026
	ldr     r11, =0x0a81
	ldr     r12, =0x4005

	ldr     r8,=UART1_BASE_ADDR	/*was 0x206080 UART1_CR1*/
	str     r10,[r8,#(UART1_CR2-UART1_BASE_ADDR)]
	str     r11,[r8,#(UART1_FCR-UART1_BASE_ADDR)]
	str     r12,[r8,#(UART1_CR1-UART1_BASE_ADDR)]
	ldr     r9,=UART2_BASE_ADDR	/*was 0x207080 UART1_CR1*/
	str     r10,[r9,#(UART2_CR2-UART2_BASE_ADDR)]
	str     r11,[r9,#(UART2_FCR-UART2_BASE_ADDR)]
	str     r12,[r9,#(UART2_CR1-UART2_BASE_ADDR)]

	/* Call standard crt0 startup code */
	ldr	r1,.LC0_crt_start
	mov	lr,#0	/* pc */
	mov	pc,r1
8:
	b	8b

.LC0:
	.word	0
.LC0_crt_start:
	.word	_crt_start

.end
