#ifndef _RESET_INFO_H_
#define _RESET_INFO_H_

/* Request to switch off device */
#define RESET_REASON_W1_SWITCH_OFF  0x65fe1a29
#define RESET_REASON_W2_SWITCH_OFF  0x23b56a9e

/* Request to switch on device */
#define RESET_REASON_W1_SWITCH_ON   0x65634a29
#define RESET_REASON_W2_SWITCH_ON   0xeab5676e

/* Information about error */
#define RESET_REASON_W1_ERROR       0xa479d234

/* OS boot abort */
#define RESET_REASON_W1_OS_BOOT     0xebf23c55

/* Loader processing error */
#define RESET_REASON_W1_LOADER      0x34e5c2ad

/* Unknown reset reason */
#define RESET_REASON_W1_UNKNOWN     0x00000000

/* Watchdog reset source */
#define RESET_SOURCE_UNKNOWN        0x00000050

/* Watchdog reset source */
#define RESET_SOURCE_WATCHDOG       0x00000051

/* Watchdog reset source */
#define RESET_SOURCE_POR            0x00000052

/* External reset source */
#define RESET_SOURCE_EXTERNAL       0x00000053


#endif /*_RESET_INFO_H_*/
