#include <cpu_def.h>
#include <irq_def.h>
#include <mx1_def.h>
#include <mx1_reg.h>
#include <types.h>
#include <stdarg.h>
#include <char_que.h>
#include <string.h>
#include <periph/mx1_boardctrl.h>
#include <reset_info.h>

extern volatile unsigned long __reset_reason_data_word1;
extern volatile unsigned long __reset_reason_data_word2;

void reset_reason_set(unsigned long word1, unsigned long word2)
{
  __reset_reason_data_word1=0;
  __reset_reason_data_word2=0;
  __reset_reason_data_word1=word1;
  __reset_reason_data_word2=word2;
}

int reset_reason_get(unsigned long *pword1, unsigned long *pword2)
{
  if(_reg_PLL_RSR & MX1_PLL_RSR_WDR_m)
  *pword1=__reset_reason_data_word1;
  *pword2=__reset_reason_data_word2;
  
  if(_reg_PLL_RSR & MX1_PLL_RSR_WDR_m)
    if(_reg_PLL_RSR & MX1_PLL_RSR_EXR_m)
      return RESET_SOURCE_UNKNOWN;
    else
      return RESET_SOURCE_WATCHDOG;
  else
    if(_reg_PLL_RSR & MX1_PLL_RSR_EXR_m)
      return RESET_SOURCE_EXTERNAL;
    else
      return RESET_SOURCE_POR;
}
