/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * Copyright (C) 2002 Motorola Semiconductors HK Ltd
 *
 */

#ifndef USB_P_DEF_INC
#define USB_P_DEF_INC

#include "types.h"

//#define	DEBUG_USB
#ifdef	DEBUG_USB
//#define DPRINTK(fmt, args...) printk("%s: " fmt, __FUNCTION__ , ## args)
#define DPRINTK(fmt, args...) printk(fmt, ## args)
#else
#define DPRINTK(fmt, args...)
#define printk(fmt, args...)
#endif

#define 	USB_DISK_START				0xFB000000	// last 16M of SDRAM
#define	TRUE							1
#define	FALSE							0

// constant for last sector from host handling
#define LAST_SECT_PENDING       1
#define LAST_SECT_DONE          2

/* error code definition */
#define ERR_USB_NO_SUPPORT      0x1A00

// device status definition
#define USB_DRV_NOT_READY       0
#define USB_DRV_READY           1

/* interrupt source definition */
#define USB_INTR_SOURCE0        47
#define USB_INTR_SOURCE1        48
#define USB_INTR_SOURCE2        49
#define USB_INTR_SOURCE3        50
#define USB_INTR_SOURCE4        51
#define USB_INTR_SOURCE5        52
#define USB_INTR_SOURCE6        53

/* DMA source definition */
#define USB_DMA_SOURCE_EP0      25
#define USB_DMA_SOURCE_EP1      26
#define USB_DMA_SOURCE_EP2      27
#define USB_DMA_SOURCE_EP3      16
#define USB_DMA_SOURCE_EP4      17

#endif
