/*********************************************************/
/***   Based on work by Roman Bartosinski 03.10.2002   ***/
/*********************************************************/

#ifndef _MX1_USB_LL_MODULE
 #define _MX1_USB_LL_MODULE


/*********************************************************/    
// Endpoints - size and index defines


  #define PDI_CNT_EP    0x03

  #define MX_USB_EP0_PACKET_SIZE  8
  #define MX_USB_EP0_TX_SIZE      8
  #define MX_USB_EP0_RX_SIZE      8
  
  #define MX_USB_EP1_PACKET_SIZE  32
  #define MX_USB_EP1_TX_SIZE      32
  #define MX_USB_EP1_RX_SIZE      32

  #define MX_USB_EP2_PACKET_SIZE  32
  #define MX_USB_EP2_TX_SIZE      32
  #define MX_USB_EP2_RX_SIZE      32

  #define MX_USB_EP3_PACKET_SIZE  16
  #define MX_USB_EP3_TX_SIZE      16

  #define MX_USB_EP0_TX  0
  #define MX_USB_EP0_RX  0
  #define MX_USB_EP1_TX  1
  #define MX_USB_EP1_RX  2
  #define MX_USB_EP2_TX  3
  #define MX_USB_EP2_RX  4
  #define MX_USB_EP3_TX  5
  // another index names
  #define MX_USB_EP0_IN   MX_USB_EP0_TX
  #define MX_USB_EP0_OUT  MX_USB_EP0_RX
  #define MX_USB_EP1_IN   MX_USB_EP1_TX
  #define MX_USB_EP1_OUT  MX_USB_EP1_RX
  #define MX_USB_EP2_IN   MX_USB_EP2_TX
  #define MX_USB_EP2_OUT  MX_USB_EP2_RX
  #define MX_USB_EP3_IN   MX_USB_EP3_TX

/*********************************************************/
//  Function prototypes
//
// MX1 common commands

int mx_usb_reset(void);
int mx_usb_init_ll(void);
int mx_usb_reset_enable_irq(void);
int mx_usb_get_frame_nr(void);
int mx_usb_ep_get_stat(int ep_num);
void mx_usb_ep_stall(int ep_num);
int mx_usb_ep_write(int ep_num, const void *data, int size);
int mx_usb_ep_read(int ep_num, void *data, int size);

#define MX_USB_RW_EP_LEN_m	0x00ffffff
#define MX_USB_RW_EP_FULL_m	0x01000000
#define MX_USB_RW_EP_EMPTY_m	0x02000000
#define MX_USB_RW_EP_NOFR_m	0x04000000
             
/*********************************************************/
#endif /* _MX1_USB_LL_MODULE */
